﻿Imports System.IO
Imports System.Linq
Public Class Form1
    Dim mylist As New List(Of AircraftFuel)
    Dim mydata(0 To 13) As AirCraftModelDetails
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim sr As New StreamReader("..\..\FuelEconomyInAirCraft.txt", FileMode.Open)

        sr.ReadLine()
        While Not sr.EndOfStream
            Dim record As String
            record = sr.ReadLine()
            Dim data() As String = record.Split(New Char() {","})

            mylist.Add(New AircraftFuel(data(0), Integer.Parse(data(1)), Integer.Parse(data(2)),
                                        Double.Parse(data(3)), Double.Parse(data(4)), Double.Parse(data(5))))


        End While

        'For Each value In mylist
        '    MessageBox.Show(NumberOfPlanes(value.Model))
        'Next
        Dim count As Integer = 0
        For Each v In DistinctModel()
            Dim ac As AirCraftModelDetails
            ac.AirPlaneModel = (DirectCast(v, AircraftFuel)).Model
            ac.NoOfPlane = NumberOfPlanes(ac.AirPlaneModel)
            ac.AvgNoOfSeats = AverageNoofSeat(ac.AirPlaneModel)
            ac.AvgSector = AverageSector(ac.AirPlaneModel)
            ac.AvgFuelBurn = AverageFuelBurn(ac.AirPlaneModel)
            ac.AvgFuelPerSeat = AverageFuelPerGallonPerSeat(ac.AirPlaneModel)
            mydata(count) = ac
            count = count + 1
        Next
        ' DataGridView1.DataSource = mydata

    End Sub

    Function DistinctModel() As IEnumerable
        Dim result = mylist.Distinct(New AircraftFuel())
        DistinctModel = result

    End Function


    Function NumberOfPlanes(model As String) As Integer
        Dim result = From data In mylist
                     Where data.Model = model

        NumberOfPlanes = result.Count


    End Function
    Function AverageFuelPerGallonPerSeat(model As String) As Double
        Dim result = From data In mylist
                     Where data.Model = model
                     Select data.FuelPerSeat
        Return Math.Round(result.Average(), 2)
    End Function
    Function AverageNoofSeat(model As String) As Integer
        Dim result = From data In mylist
                     Where data.Model = model
                     Select data.Seats
        Return result.Average()
    End Function
    Function AverageSector(model As String) As Double
        Dim result = From data In mylist
                     Where data.Model = model
                     Select data.Sector
        Return result.Average()
    End Function
    Function AverageFuelBurn(model As String) As Double
        Dim result = From data In mylist
                     Where data.Model = model
                     Select data.FuelBurn
        Return result.Average()
    End Function

    Private Sub ComputeFuel_Click(sender As Object, e As EventArgs) Handles ComputeFuel.Click
        DisplayComputeFule()
    End Sub

    Private Sub AirplaneDetails_Click(sender As Object, e As EventArgs) Handles AirplaneDetails.Click
        GetInput()
    End Sub
    Sub GetInput()
        Dim result = InputBox("Enter the Plane Model", "Airplane Details")

        DisplayAirplaneDetails(result)

    End Sub
    Sub DisplayAirplaneDetails(model As String)
        Dim result = From d In mydata
                     Where d.AirPlaneModel = model
        If result.Count = 0 Then
            MessageBox.Show("There is No known " + model + " Airplane Model")
            Exit Sub
        End If
        For Each v In result
            txtAirplaneDetails.Text = "Airport Model                          :" + vbTab + v.AirPlaneModel + vbCrLf
            txtAirplaneDetails.AppendText("Number of Seats                    :" + vbTab + v.AvgNoOfSeats.ToString() + vbCrLf)
            txtAirplaneDetails.AppendText("Sector                             :" + vbTab + v.AvgSector.ToString() + vbCrLf)
            txtAirplaneDetails.AppendText("Fuel Burn                          :" + vbTab + v.AvgFuelBurn.ToString() + vbCrLf)
            txtAirplaneDetails.AppendText("Fuel Per Seat                      :" + vbTab + v.AvgFuelPerSeat.ToString() + vbCrLf)
            txtAirplaneDetails.AppendText("Total Fuel Consumption Round Trip  :" + vbTab + RoundTripFuel(v.AvgNoOfSeats, v.AvgSector, v.AvgFuelBurn, v.AvgFuelPerSeat).ToString() + vbCrLf)

        Next


    End Sub
    Function RoundTripFuel(NoOfSeats As Double, Sector As Double, FuelBurn As Double, FuelPerSeat As Double) As Double
        Dim FuelPerSeatPerMileInlbs = FuelPerSeat * 8.35
        Dim FuelPerSeatForEntireSectorInlbs = Sector / FuelPerSeatPerMileInlbs
        Dim FuelForAllSeatsForEntireSectorInlbs = FuelPerSeatForEntireSectorInlbs * NoOfSeats
        Dim FuelBurnForTheEntireJourney = Sector * FuelBurn
        Dim TotalFuelConsumption = FuelForAllSeatsForEntireSectorInlbs + FuelBurnForTheEntireJourney
        Return Math.Round(TotalFuelConsumption * 2, 2)
    End Function
    Sub DisplayComputeFule()
        Dim result = From data In mydata
                     Select (New With {.Model = data.AirPlaneModel, .FuelPerGallonPerSeat = Math.Round(data.AvgFuelPerSeat, 2)})
        DataGridView1.DataSource = result.ToList()

    End Sub


End Class
